var Expression = require('fire').Expression
var mongodb = require('mongodb');

function MongoBaseExpression() {
	
}

MongoBaseExpression.prototype = new Expression()

MongoBaseExpression.prototype.useConnection = function(readyCallback) {
	var self = this
	var config = this.runtime._mongoDbConnInfo
	if(!config) {
		console.warn("useConnection", this.runtime.environmentName, this.runtime.configurations)	
	}
	//
	var server = new mongodb.Server(config.host, config.port, config.options || {});
	new mongodb.Db(config.db, server, {}).open(function (error, client) {
		if(error) {
			self.raiseError(error)
			return
		} else {
			if(config.username || config.password) {
				client.authenticate(config.username,config.password, function(authError) {
					if(authError) {
						self.raiseError(authError)
					} else {
						readyCallback(client)
					}
				} )
			} else {
				readyCallback(client)
			}
		}
	});
}

module.exports = MongoBaseExpression